<template>
  <el-dialog
    :visible.sync="visible"
    :title="!dataForm.id ? $t('add') : $t('update')"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    :modal="false"
  >
    <el-form
      :model="dataForm"
      :rules="dataRule"
      ref="dataForm"
      @keyup.enter.native="dataFormSubmitHandle()"
      label-width="120px"
    >
      <el-form-item prop="name" :label="$t('dept.name')">
        <el-input
          v-model="dataForm.name"
          :placeholder="$t('dept.name')"
        ></el-input>
      </el-form-item>
      <el-form-item
        prop="parentName"
        :label="$t('dept.parentName')"
        class="dept-list"
      >
        <el-popover
          v-model="deptListVisible"
          ref="deptListPopover"
          placement="bottom-start"
          trigger="click"
        >
          <el-tree
            :data="deptList"
            :props="{ label: 'name', children: 'children' }"
            node-key="id"
            ref="deptListTree"
            :highlight-current="true"
            :expand-on-click-node="false"
            accordion
            @current-change="deptListTreeCurrentChangeHandle"
          >
          </el-tree>
        </el-popover>

        <el-input
          v-model="dataForm.parentName"
          v-popover:deptListPopover
          :readonly="true"
          :placeholder="$t('dept.parentName')"
        >
          <i
            v-if="$store.state.user.superAdmin === 1 && dataForm.pid !== '0'"
            slot="suffix"
            @click.stop="deptListTreeSetDefaultHandle()"
            class="el-icon-circle-close el-input__icon"
          >
          </i>
        </el-input>
      </el-form-item>
      <el-form-item prop="deptType" :label="$t('dept.deptType')">
        <el-radio-group
          v-model="dataForm.deptType"
          :disabled="dataForm.id ? true : false"
        >
          <el-radio label="0">{{ $t("dept.deptType0") }}</el-radio>
          <el-radio label="1">社区</el-radio>
          <el-radio label="2">小区</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item prop="logo" :label="$t('dept.Logo')">
        <el-row style="">
          <el-col :span="12" style="color: white">
            <el-upload
              :action="url"
              :file-list="fileList"
              drag
              :show-file-list="false"
              :before-upload="beforeUploadHandle"
              :on-success="successHandle"
              class="text-left"
              ref="myupload"
            >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text" v-html="$t('upload.text')"></div>
              <div class="el-upload__tip" slot="tip">
                {{ $t("upload.tip", { format: "jpg、png、gif" }) }}
              </div>
            </el-upload>
          </el-col>
          <el-col :span="12">
            <div style="position: relative">
              <img style="width: 250px" :src="dataForm.logo" alt="" />
            </div>
          </el-col>
        </el-row>
      </el-form-item>
      <el-form-item prop="remark" :label="$t('dept.remark')">
        <el-input v-model="dataForm.remark" type="textarea"></el-input>
      </el-form-item>
      <el-form-item prop="sort" :label="$t('dept.sort')">
        <el-input-number
          v-model="dataForm.sort"
          controls-position="right"
          :precision="0"
          :step-strictly="true"
          :step="1"
          :min="0"
          :label="$t('dept.sort')"
        ></el-input-number>
      </el-form-item>
    </el-form>
    <template slot="footer">
      <el-button @click="visible = false">{{ $t("cancel") }}</el-button>
      <el-button type="primary" @click="dataFormSubmitHandle()">{{
        $t("confirm")
      }}</el-button>
    </template>
  </el-dialog>
</template>

<script>
import debounce from "lodash/debounce";
import Cookies from "js-cookie";
export default {
  data() {
    return {
      visible: false,
      deptList: [],
      deptListVisible: false,
      dataForm: {
        id: "",
        name: "",
        pid: "",
        parentName: "",
        deptType: "0",
        remark: "",
        logo: "",
        sort: 0,
      },
      url: "",
      num: 0,
      fileList: [],
      myupload: {},
      isShowImgUpload: false,
      parentData: {},
    };
  },
  computed: {
    dataRule() {
      return {
        name: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        parentName: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
      };
    },
  },
  methods: {
    init() {
      this.url = `${
        window.SITE_CONFIG["apiURL"]
      }/sys/oss/uploadFile?token=${Cookies.get("token")}`;
      this.fileList = [];

      this.num = 0;
      (this.remark = ""), (this.isShowImgUpload = false);
      this.visible = true;
      if (this.$refs.myupload != null) {
        this.$refs.myupload.clearFiles();
      }
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        this.getDeptList().then(() => {
          if (this.dataForm.id) {
            this.getInfo();
          } else if (this.dataForm.parentData != {}) {
            this.dataForm.pid = this.parentData.id;
            this.dataForm.parentName = this.parentData.name;
            this.dataForm.deptType = (
              (this.parentData.deptType == null
                ? -1
                : parseInt(this.parentData.deptType)) + 1
            ).toString();
            this.$refs.deptListTree.setCurrentKey(this.parentData.id);
            this.parentData = {};
          } else if (this.$store.state.user.superAdmin === 1) {
            this.deptListTreeSetDefaultHandle();
          }
        });
      });
    },
    // 获取部门列表
    getDeptList() {
      return this.$http
        .get("/sys/dept/list")
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.deptList = res.data;
        })
        .catch(() => {});
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/sys/dept/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
          this.isShowImgUpload = true;
          if (this.dataForm.pid === "0") {
            return this.deptListTreeSetDefaultHandle();
          }
          this.$refs.deptListTree.setCurrentKey(this.dataForm.pid);
        })
        .catch(() => {});
    },
    // 上级部门树, 设置默认值
    deptListTreeSetDefaultHandle() {
      this.dataForm.pid = "0";
      this.dataForm.parentName = this.$t("dept.parentNameDefault");
    },
    // 上级部门树, 选中
    deptListTreeCurrentChangeHandle(data) {
      this.dataForm.pid = data.id;
      this.dataForm.parentName = data.name;
      this.deptListVisible = false;
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](
            "/sys/dept",
            this.dataForm
          )
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.$refs.myupload.clearFiles();
                  this.visible = false;
                  this.$emit("refreshDataList");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
    beforeUploadHandle(file) {
      if (
        file.type !== "image/jpg" &&
        file.type !== "image/jpeg" &&
        file.type !== "image/png" &&
        file.type !== "image/gif"
      ) {
        this.$message.error(this.$t("upload.tip", { format: "jpg、png、gif" }));
        return false;
      }
      this.num++;
    },
    // 上传成功
    successHandle(res, file, fileList) {
      if (res.code !== 0) {
        return this.$message.error(res.msg);
      }
      this.fileList = fileList;
      this.num--;
      if (this.num === 0) {
        this.$message({
          message: this.$t("prompt.success"),
          type: "success",
          duration: 500,
          onClose: () => {},
        });
        this.dataForm.logo = res.data;

        this.isShowImgUpload = true;
      }
    },
  },
};
</script>

<style lang="scss">
.mod-sys__dept {
  .dept-list {
    .el-input__inner,
    .el-input__suffix {
      cursor: pointer;
    }
  }
}
</style>
